Skip to main content
`Ctrl`+`K`
scipy.optimize.

# nnls

scipy.optimize.nnls(A, b, *, maxiter=None, atol=<object object>)

  Solve `argmin_x || Ax - b ||_2` for `x>=0`.

  This problem, often called as NonNegative Least Squares, is a convex optimization problem with convex constraints. It typically arises when the `x` models quantities for which only nonnegative values are attainable; weight of ingredients, component costs and so on.

  Deprecated since version 1.18.0: Use of argument(s) `{'maxiter'}` by position is deprecated; beginning in SciPy 1.18.0, these will be keyword-only. Argument(s) `{'atol'}` are deprecated, whether passed by position or keyword; they will be removed in SciPy 1.18.0.

  Parameters:
    A(m, n) ndarray

      Coefficient array

    b(m,) ndarray, float

      Right-hand side vector.

    maxiter: int, optional

      Maximum number of iterations, optional. Default value is `3 * n`.

    atol float, optional

      Deprecated since version 1.18.0: This parameter is deprecated and will be removed in SciPy 1.18.0. It is not used in the implementation.

  Returns:
    x ndarray

      Solution vector.

    rnorm float

      The 2-norm of the residual, `|| Ax-b ||_2`.

  See also

  `lsq_linear`

    Linear least squares with bounds on the variables

  Notes

  The code is based on the classical algorithm of [1]. It utilizes an active set method and solves the KKK (Karush-Kuhn-Tucker) conditions for the non-negative least squares problem.

  References

  [1]

  : Lawson C., Hanson R.J., “Solving Least Squares Problems”, SIAM, 1995, DOI:10.1137/1.9781611971217

  Examples

      >>> import numpy as np
      >>> from scipy.optimize import nnls
      ...
      >>> A = np.array([[1, 0], [1, 0], [0, 1]])
      >>> b = np.array([2, 1, 1])
      >>> nnls(A, b)
      (array([1.5, 1. ]), 0.7071067811865475)

      >>> b = np.array([-1, -1, -1])
      >>> nnls(A, b)
      (array([0., 0.]), 1.7320508075688772)